
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>纸上谈兵: AVL树[转] / iVAN</title>

    <meta name="description" content="纸上谈兵: AVL树[转] 二叉搜索树的深度与搜索效率 我们在树, 二叉树, 二叉搜索树中提到,一个有n个节点的二叉树,它的最小深度为log(n),最大深度为n.比如下面两个二叉树: 深度为n的二叉树 深度为log(n)的二叉树 这两个二叉树同时也是二叉搜索树(参考树, 二叉树, 二叉搜索树).注意,log以2为基底.log(n)是指深度的量级.根据我们对深度的定义,精确的最小深度为floor(log(n)+1). 我们将处于同一深度的节点归为一层.如果除最后一层外的其他层都被节点填满时,二叉树有最小深度log(n). 二">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">纸上谈兵: AVL树[转]</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>二叉搜索树的深度与搜索效率</h3>
<p>我们在<a href="http://www.cnblogs.com/vamei/archive/2013/03/17/2962290.html" rel="external nofollow noreferrer">树, 二叉树, 二叉搜索树</a>中提到，一个有n个节点的二叉树，它的最小深度为log(n)，最大深度为n。比如下面两个二叉树:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgxOTI3MDgtMzNmNzI3NWRiOGYwNGYyOWJjZWIxMDFkYjhlMzYzZWQucG5n.jpg"></p>
<p>深度为n的二叉树</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgxOTMxNDYtNTRjNDBiNDAyN2ZmNDQyZmIzMTk5NTQzYzdmNDJkOGUucG5n.jpg"></p>
<p>深度为log(n)的二叉树</p>
<p>这两个二叉树同时也是二叉搜索树(参考<a href="http://www.cnblogs.com/vamei/archive/2013/03/17/2962290.html" rel="external nofollow noreferrer">树, 二叉树, 二叉搜索树</a>)。注意，log以2为基底。log(n)是指深度的量级。根据我们对深度的定义，精确的最小深度为floor(log(n)+1)。</p>
<p>我们将处于同一深度的节点归为一层。如果除最后一层外的其他层都被节点填满时，二叉树有最小深度log(n)。</p>
<p>二叉搜索树的深度越小，那么搜索所需要的运算时间越小。一个深度为log(n)的二叉搜索树，搜索算法的时间复杂度也是log(n)。然而，我们在<a href="http://www.cnblogs.com/vamei/archive/2013/03/17/2962290.html" rel="external nofollow noreferrer">二叉搜索树</a>中已经实现的插入和删除操作并不能让保持log(n)的深度。如果我们按照8，7，6，5，4，3，2，1的顺序插入节点，那么就是一个深度为n的二叉树。那么，搜索算法的时间复杂度为n。</p>
<p> </p>
<p>n和log(n)的时间复杂度意味着什么呢？时间复杂度代表了完成算法所需要的运算次数。时间复杂度越小，算法的速度越快。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgxOTU0MzMtNzE0ZWYyYjI4Y2Q5NDJjZDhiNDc5MzBkOGRiYjNhNWUuanBn.jpg"></p>
<p>可以看到，随着元素的增加，log(n)的时间复杂度的增长要远小于n。所以，我们自然希望二叉搜索树能尽可能保持log(n)的深<br />
度。在上面深度为n的例子中，我们发现，每个节点只有左节点被填满。树的每一层都有很多空位。能不能尽可能减少每一层的空位呢？<br />
(相应的，减少树的深度)</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMjMyMTQzMjQtNDYwMzVhNjJmNWYxNDFiYmI4NmE0YTdkY2QyZWNkNmQuanBn.jpg"></p>
<p>“紧致”的树</p>
<p>一种想法是先填满一层，再去填充下一层，这样就是一个完全二叉树(complete binary tree)。这样的二叉树实现插入算法会比较复杂。我们将介绍一种思路相似，但比较容易实现的树状数据结构——AVL树。</p>
<p> </p>
<h3>AVL树</h3>
<p>AVL树是根据它的发明者G. M. Adelson-Velskii和E. M. Landis命名的。它是一种特殊的二叉搜索树。AVL树要求: 任一节点的左子树深度和右子树深度相差不超过1</p>
<p>(空树的深度为0。注意，有的教材中，采用了不同的深度定义方法，所以空树的深度为-1)</p>
<p> </p>
<p>下面是AVL树:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgyMjIwMTktMzkwN2IxY2YwYWYwNDAzY2I4ZjI0NTA0MzYyODJkY2YucG5n.jpg"></p>
<p>AVL树</p>
<p>AVL树的特性让二叉搜索树的节点实现平衡(balance)：节点相对均匀分布，而不是偏向某一侧。因此，AVL树的搜索算法复杂度是log(n)的量级。</p>
<p>我们在<a href="http://www.cnblogs.com/vamei/archive/2013/03/17/2962290.html" rel="external nofollow noreferrer">二叉搜索树</a>中定义的操作，除了插入，都可以用在AVL树上 (假设使用懒惰删除)。如果进行插入操作，有可能会破坏AVL树的性质，比如:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgyMzE3NTktMTMyNDc4OWE1NzcyNDZlY2E0NTQ4OWE0ZGFmZjg0NDAucG5n.jpg"></p>
<p>插入2: 破坏AVL树</p>
<p>观察节点5，它的左子树深度为2，右子树深度为0，所以左右两个子树深度相差为2，不再是AVL树。由于2的加入，从节点<br />
6，1，5，3到2的层数都增加1。6, 1,<br />
5节点的AVL性质都被破坏。如果从节点2向上回溯，节点5是第一个被破坏的。从节点3开始的子树深度加1，这是造成6, 1,<br />
5的AVL性质被破坏的本质原因。我们将5和3之间的路径画成虚线(就好像挂了重物，边被拉断一样)。</p>
<p> </p>
<p>我们可以通过单旋照(single rotation)，调整以5为根节点的子树，来修正因为插入一个元素而引起的对AVL性质的破坏。如下:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgyMzIwNTEtMzcwYmQ0YTE5ZTNhNGU3Zjg3MWZkMTUzYzdkM2Q5N2EucG5n.jpg"></p>
<p>Single rotation: 左侧超重，向右转</p>
<p>通过单旋转，3成为新的根节点，2,5称为3的左右子节点。子树重新成为AVL树。该子树的深度减小1，这将自动修正2带给节点6,1的“超负荷”。</p>
<p> </p>
<p>单旋转效果如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMjAyMDM0MTgtNmM5NmRmMzJlMjk4NDM0NjlhNjVmZmY5YTRhNTc1NDAucG5n.jpg"> 向右单旋转</p>
<p>特别要注意的是，为了保持二叉树的性质，子树B过继给了节点5。</p>
<p>向左单旋转与之类似。作为练习，可以尝试绘制向左单旋转的示意图。</p>
<p> </p>
<p>但如果插入的节点不是2，而是4，会是如何呢？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTgyMzI1NDUtMDM2Y2U0ZDU4N2I0NDE5NGIyOGU3Nzc3ZWY5ZTNjMWYucG5n.jpg"></p>
<p>插入4</p>
<p>尝试单旋转，会发现无法解决问题。以5为根节点的子树向右单旋转后，树将以3为根节点，4,5为子节点。4比3大，却是3的左子节点，显然，这依然不符合二叉搜索树的性质。但基于和上面相似的原则(调整以5为根节点的树)，我们发现有一个简单的解决方式：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMTkwMDM2MTQtMWNjMzVjMTlhODE0NDBjY2IyZWYwNDFhY2NmNTdmMGMucG5n.jpg"></p>
<p>double rotation</p>
<p> </p>
<p>上面的操作被称作双旋转(double rotation)。双旋转实际上是进行两次单旋转: 4为根节点的子树先进行一次向左的单旋转，然后将5为根节点的子树进行了一次向右的单旋转。这样恢复了树的ACL性质。</p>
<p> </p>
<p>对于AVL树，可以证明，在新增一个节点时，总可以通过一次旋转恢复AVL树的性质。</p>
<p>当我们插入一个新的节点时，在哪里旋转？是用单旋转还是双旋转?</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQxMzQxNi8yMDEzMDMvMjAyMDI3MzQtMmI2NmU5ZWQ3MGQwNDNmY2JiMWQwMmIzZWIwNWE3ODAucG5n.jpg"></p>
<p>我们按照如下基本步骤进行：</p>
<p>1. 按照二叉搜索树的方式增加节点，新增节点称为一个叶节点。</p>
<p>2. 从新增节点开始，回溯到第一个失衡节点(5)。</p>
<p>    (如果回溯到根节点，还没有失衡节点，就说明该树已经符合AVL性质。)</p>
<p>3. 找到断的边(5-&gt;3)，并确定断弦的方向(5的左侧)</p>
<p>4. 以断边下端(3)为根节点，确定两个子树中的哪一个深度大(左子树还是右子树)。</p>
<p>    (这两棵子树的深度不可能相等，而且深度大的子树包含有新增节点。想想为什么)</p>
<p>5. 如果第2和第3步中的方向一致(都为左或者都为右)，需要单旋转以失衡节点为根节点的子树。</p>
<p>    否则，双旋转以失衡节点为根节点的子树。</p>
<p> </p>
<p>下面是AVL树的插入算法实现如下:</p>
<pre><code>/* By Vamei */
/* binary search tree */
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

typedef struct node *position;
typedef int ElementTP;

struct node {
    int depth;
    position parent;
    ElementTP element;
    position lchild;
    position rchild;
};

/* pointer =&gt; root node of the tree */
typedef struct node *TREE;

position insert_value(TREE, ElementTP);
int depth(TREE);

static void insert_node_to_nonempty_tree(TREE, position);
static void update_root_depth(TREE);
static TREE recover_avl(TREE, position);
static int depth_diff(TREE);
static position insert_leaf(TREE, ElementTP);
static void insert_node_to_nonempty_tree(TREE, position);
static TREE left_single_rotate(TREE);
static TREE left_double_rotate(TREE);
static TREE right_single_rotate(TREE);
static TREE right_double_rotate(TREE);

void main(void)
{
    TREE tr;
    position np;
    ElementTP element;
    tr = NULL;
    tr = insert_value(tr, 18);
    tr = insert_value(tr, 5);
    printf("root: %d\n", tr-&gt;element);
    printf("depth: %d\n", depth(tr));
    tr = insert_value(tr, 2);
    printf("root: %d\n", tr-&gt;element);
    printf("depth: %d\n", depth(tr));
    tr = insert_value(tr, 4);
    printf("root: %d\n", tr-&gt;element);
    printf("depth: %d\n", depth(tr));
    printf("root-&gt;lchild: %d\n", tr-&gt;lchild-&gt;element);
    tr = insert_value(tr, 3);
    printf("root: %d\n", tr-&gt;element);
    printf("depth: %d\n", depth(tr));
    printf("root-&gt;lchild: %d\n", tr-&gt;lchild-&gt;element);
    printf("root-&gt;lchild-&gt;lchild: %d\n", tr-&gt;lchild-&gt;lchild-&gt;element);
}

/*
 * insert value
 *
 */
position insert_value(TREE tr, ElementTP value)
{
    position new;

    /* insert a value to a binary search tree */
    new = insert_leaf(tr, value);
    update_root_depth(new);
    if (tr == NULL) {
        tr = new;
    }
    else {
        tr = recover_avl(tr, new);
    }
    return tr;
}

/*
 * get the depth of the tree
 * use this function to access depth
 */
int depth(TREE tr) {
    if (tr == NULL) {
        return 0;
    }
    else {
        return tr-&gt;depth;
    }
}

//========================================
// static functions: for internal use

/*
 * traverse the path from new node to root node
 * make one rotation, recover AVL and stop
 */
static TREE recover_avl(TREE tr, position np)
{
    int myDiff;
    while (np != NULL) {
        update_root_depth(np);
        myDiff = depth_diff(np);
    if (myDiff &gt; 1 || myDiff &lt; -1) {
            if (myDiff &gt; 1) {
                /* left rotate needed */
                if(depth_diff(np-&gt;rchild) &gt; 0) {
                    np = left_single_rotate(np);
                }
                else {
                    np = left_double_rotate(np);
                }
            }
            if (myDiff &lt; -1) {
                if(depth_diff(np-&gt;lchild) &lt; 0) {
                    np = right_single_rotate(np);
                }
                else {
                    np = right_double_rotate(np);
                }
            }
            /* if rotation changes root node */
            if (np-&gt;parent == NULL) tr = np;
            break;
        }
        np = np-&gt;parent;
    }

    return tr;
}

/*
 * difference of rchild-&gt;depth and lchild-&gt;depth
 */
static int depth_diff(TREE tr)
{
    if (tr == NULL) {
        return 0;
    }
    else {
        return depth(tr-&gt;rchild) - depth(tr-&gt;lchild);
    }
}

/*
 * left single rotation
 * return the new root
 */
static TREE left_single_rotate(TREE tr)
{
    TREE newRoot, parent;
    parent  = tr-&gt;parent;
    newRoot = tr-&gt;rchild;
    /* detach &amp; attach */
    if (newRoot-&gt;lchild != NULL) newRoot-&gt;lchild-&gt;parent = tr;
    tr-&gt;rchild = newRoot-&gt;lchild;
    update_root_depth(tr);

    /* raise new root node */
    newRoot-&gt;lchild = tr;
    newRoot-&gt;parent = parent;
    if (parent != NULL) {
        if (parent-&gt;lchild == tr) {
        parent-&gt;lchild = newRoot;
    }
    else {
        parent-&gt;rchild = newRoot;
    }
    }
    tr-&gt;parent = newRoot;
    update_root_depth(newRoot);
    return newRoot;
}

/*
 * right single rotation
 * return the new root
 */
static TREE right_single_rotate(TREE tr)
{
    TREE newRoot, parent;
    parent  = tr-&gt;parent;
    newRoot = tr-&gt;lchild;

    /* detach &amp; attach */
    if (newRoot-&gt;rchild != NULL) newRoot-&gt;rchild-&gt;parent = tr;
    tr-&gt;lchild = newRoot-&gt;rchild;
    update_root_depth(tr);

    /* raise new root node */
    newRoot-&gt;rchild = tr;
    newRoot-&gt;parent = parent;
    if (parent != NULL) {
        if (parent-&gt;lchild == tr) {
        parent-&gt;lchild = newRoot;
    }
    else {
        parent-&gt;rchild = newRoot;
    }
    }
    tr-&gt;parent = newRoot;
    update_root_depth(newRoot);
    return newRoot;
}

/*
 * left double rotation
 * return
 */
static TREE left_double_rotate(TREE tr)
{
    right_single_rotate(tr-&gt;rchild);
    return left_single_rotate(tr);
}

/*
 * right double rotation
 * return
 */
static TREE right_double_rotate(TREE tr)
{
    left_single_rotate(tr-&gt;lchild);
    return right_single_rotate(tr);
}

/*
 * update tr-&gt;depth
 * assume lchild-&gt;depth and rchild-&gt;depth are correct
 */
static void update_root_depth(TREE tr)
{
    int maxChildDepth;
    int depLChild, depRChild;
    if (tr==NULL) return;
    else {
        depLChild = depth(tr-&gt;lchild);
        depRChild = depth(tr-&gt;rchild);
        maxChildDepth = depLChild &gt; depRChild ? depLChild : depRChild;
        tr-&gt;depth = maxChildDepth + 1;
    }
}

/*
 * insert a new value into the tree as a leaf
 * return address of the new node
 */
static position insert_leaf(TREE tr, ElementTP value)
{
    position np;
    /* prepare the node */
    np = (position) malloc(sizeof(struct node));
    np-&gt;element = value;
    np-&gt;parent  = NULL;
    np-&gt;lchild  = NULL;
    np-&gt;rchild  = NULL;

    if (tr != NULL) {
        insert_node_to_nonempty_tree(tr, np);
    }
    return np;
}

/*
 * insert a node to a non-empty tree
 * called by insert_value()
 */
static void insert_node_to_nonempty_tree(TREE tr, position np)
{
    /* insert the node */
    if(np-&gt;element &lt;= tr-&gt;element) {
        if (tr-&gt;lchild == NULL) {
            /* then tr-&gt;lchild is the proper place */
            tr-&gt;lchild = np;
            np-&gt;parent = tr;
            return;
        }
        else {
            insert_node_to_nonempty_tree(tr-&gt;lchild, np);
        }
    }
    else if(np-&gt;element &gt; tr-&gt;element) {
        if (tr-&gt;rchild == NULL) {
            tr-&gt;rchild = np;
            np-&gt;parent = tr;
            return;
        }
        else {
            insert_node_to_nonempty_tree(tr-&gt;rchild, np);
        }
    }
}</code></pre>
<p> </p>
<p>输出如下：</p>
<p>root: 18<br />
depth: 2</p>
<p>root: 5<br />
depth: 2</p>
<p>root: 5<br />
depth: 3<br />
root-&gt;lchild: 2</p>
<p>depth: 3<br />
root-&gt;lchild: 3<br />
root-&gt;lchild-&gt;lchild: 2</p>
<p>(空行是额外加的)</p>
<p> </p>
<p>总结:</p>
<p>AVL树: 平衡，深度相差不超过1</p>
<p>单旋转，双旋转</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 08:17:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>纸上谈兵: AVL树[转]的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyPRNEb.html" rel="bookmark">纸上谈兵&colon; AVL树</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:Vamei 出处:http://www.cnblogs.com/vamei 欢迎转载,也请保留这段声明.谢谢!   二叉搜索树的深度与搜索效率 我们在树, 二叉树, 二叉搜索树中提到,一个有n个节点的二叉树,它的最小深度为log(n),最大深度为n.比如下面两个二叉树: 深度为n的二叉树 深度为log(n)的二叉树 这两个二叉树同时也是二叉搜索树(参考树, 二叉树, 二叉搜索树).注意,log以2为基底.log(n)是指深度的量级.根据我们对深度的定义,精确的最小深度为floor(log(			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBWkDb.html" rel="bookmark">纸上谈兵&colon; 伸展树 &lpar;splay tree&rpar;&lbrack;转&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:Vamei 出处:http://www.cnblogs.com/vamei 欢迎转载,也请保留这段声明.谢谢!    我们讨论过,树的搜索效率与树的深度有关.二叉搜索树的深度可能为n,这种情况下,每次搜索的复杂度为n的量级.AVL树通过动态平衡树的深度,单次搜索的复杂度为log(n) (以上参考纸上谈兵 AVL树).我们下面看伸展树(splay tree),它对于m次连续搜索操作有很好的效率.   伸展树会在一次搜索后,对树进行一些特殊的操作.这些操作的理念与AVL树有些类似,即通过旋转,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Ml085NM.html" rel="bookmark">纸上谈兵&colon; 伸展树 &lpar;splay tree&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:Vamei 出处:http://www.cnblogs.com/vamei 欢迎转载,也请保留这段声明.谢谢!    我们讨论过,树的搜索效率与树的深度有关.二叉搜索树的深度可能为n,这种情况下,每次搜索的复杂度为n的量级.AVL树通过动态平衡树的深度,单次搜索的复杂度为log(n) (以上参考纸上谈兵 AVL树).我们下面看伸展树(splay tree),它对于m次连续搜索操作有很好的效率.   伸展树会在一次搜索后,对树进行一些特殊的操作.这些操作的理念与AVL树有些类似,即通过旋转,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM6yxWb.html" rel="bookmark">平衡二叉树&colon;php实现平衡二叉树&lpar;avl树&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;?phprequire 'bstorder.php';$test = range(1, 10);//$test = array(3,9,1,4,8,5,7,6,2,10);$tree = new bst($test, true);//$tree-&gt;deletenode('30');(非平衡树可删除,平衡树的没写删除操作)print_r($tree-&gt;gettree());?&gt;bstorder.php&lt;?php/*** php实现二叉排序树* @author zhaojian			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqLDg3b.html" rel="bookmark">AVL树的实现代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文配套源码 /******************************************************************** created: 2007/08/28 filename: avltree.c author: Lichuang purpose: AVL树的实现代码, 参考资料&lt;&lt;数据结构与算法分析-C语言描述&gt;&gt;, 作者Allen Weiss **************************************************			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3vjZz.html" rel="bookmark">二叉树学习笔记之经典平衡二叉树（AVL树）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				二叉查找树(BSTree)中进行查找.插入和删除操作的时间复杂度都是O(h),其中h为树的高度.BST的高度直接影响到操作实现的性能,最坏情况下,二叉查找树会退化成一个单链表,比如插入的节点序列本身就有序,这时候性能会下降到O(n).可见在树的规模固定的前提下,BST的高度越低越好. 平衡二叉树 平衡二叉树是计算机科学中的一类改进的二叉查找树. 平衡二叉树具有以下性质: (1)一棵空树是平衡二叉树 (2)如果树不为空,它的左右两个子树的高度差的绝对值不超过1,并且左右两个子树都是一棵平衡二叉树.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxorayb.html" rel="bookmark">AVL树的研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3 实现算法  3.1 数据结构 template&lt;typename T&gt;struct BSTNode//平衡二叉树的结点类型结构体 {        T data;//结点数据类型        int bf;//结点的平衡因子,比二叉链表结点多此项        BSTNode&lt;T&gt;*lchild,*rchild;//左右孩子指针 };   3.2 算法   3.2．1 递归法 递归实现AVL树的节点删除的思想如下.    在AVL树T上删除值为E的节点步骤如下: (1)   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7n6Az.html" rel="bookmark">AVL树的删除探讨</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AVL树的删除很多教材上都没有提供,本人对AVL树有着较为深入的研究.现在晒出大体的算法思想.  3.2．1 递归法 递归实现AVL树的结点删除的思想如下.    在AVL树T上删除值为E的结点步骤如下: (1)       若树T为空,返回0退出否则到(2); (2)       比较T的数据和E,若相等跳到(3),若E小于T-&gt;data跳到(4),若E大于T-&gt;data则跳到(5) (3)       分析T结点的类型 (3.1)若T是叶子结点则直接删除,树变矮即lower=1: (3.2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW296jb.html" rel="bookmark">Python数据结构&mdash;&mdash;AVL树的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				既然,我们已经证明,保持 AVL 树的平衡将会使性能得到很大的提升,那我们看看如何在程序中向树插入一个新的键值.因为所有的新键是作为叶节点插入树的,而新叶子的平衡因子为零,所以我们对新插入的节点不作调整.不过一旦有新叶子的插入我们必须更新其父节点的平衡因子.新叶子会如何影响父节点的平衡因子取决于叶节点是左子节点还是右子节点.如果新节点是右子节点,父节点的平衡因子减 1.如果新节点是左子节点,父节点的平衡因子将加 1.这种关系可以递归地应用于新节点的前两个节点,并有可能影响到之前的每一个甚至是根节			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP1BAz.html" rel="bookmark" class="title">JScript 的运算符</a>
					<div>
						js|jscript|运算 JScript 具有全范围的运算符,包括算术.逻辑.位.赋值以及其他某些运算符. 计算 逻辑 位运算 赋值 杂项           描述 符号 描述 符号 描述 符号 描 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4Aqjb.html" rel="bookmark" class="title">&amp;amp&semi;&num;106avascript对象与数组参考大全&lpar;1&rpar;</a>
					<div>
						参考|对象|数组 本文列举了各种JavaScript对象与数组,同时包括对上述每一对象或数组所完成工作的简短描述,以及与其相关的属性方法,以及事件处理程序,还注明了该对象或数组的父对象用户同样可能需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlaOmb.html" rel="bookmark" class="title">UC浏览器电脑版怎么截图</a>
					<div>
						  UC浏览器电脑版自带截图插件,大家在浏览网页和视频时可以快速清晰的截图屏幕图像,如果还没体验过的朋友可以参考一下这篇uc浏览器电脑版截图方法. UC浏览器电脑版怎么截图? 1.在UC浏览器电脑版中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62K3OM.html" rel="bookmark" class="title">Excel解除合并如何保留原数据</a>
					<div>
						  首先自然是选中要取消合并的单元格,再点击&quot;合并后居中&quot;,从下拉菜单里选择&quot;取消单元格合并&quot;. 接下来接Ctrl+G键或者按F5键,调出定位窗口. 定位条件要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ78nJb.html" rel="bookmark" class="title">Win8应用打不开的解决方法</a>
					<div>
						刚装完windows8后,或许我们会马上切换到administrator账户,或者把之前创建的管理员账户删除,真正使用administrator账户后,我们会发现一些应用不能用了,比如开始菜单的天气等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPydrz.html" rel="bookmark" class="title">PHP实现格式化文件数据大小显示的方法</a>
					<div>
						 这篇文章主要介绍了PHP实现格式化文件数据大小显示的方法,通过一个自定义函数实现针对文件大小的精确格式化,具有一定的参考借鉴价值,需要的朋友可以参考下     本文实例讲述了PHP实现格式化文件数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLKdkb.html" rel="bookmark" class="title">稻草人快速打开远程协助</a>
					<div>
						  &quot;远程协助&quot;是Windows系统附带的一种简单的远程控制计算机的方法.这项功能可以帮助处理被控计算机的系统维护.安装软件等问题,或者向被协助者演示某些操作.由于小白用户平时很少 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLDjEb.html" rel="bookmark" class="title">如何在Window8中挂载一个ISO文件</a>
					<div>
						  1.鼠标左键双击 ISO 映像文件即可挂载.如下图所示: 2.计算机中会出现一个虚拟的光驱盘符.如下图所示: 3.鼠标左键双击虚拟光驱盘符,之后就可以像进入了光驱的形式进行操作.如下图所示: 4. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8KADp.html" rel="bookmark" class="title">上网前宽带连接打不开怎么办</a>
					<div>
						步骤一.如果桌面上有宽带连接的快捷键我们先将其删除,然后右键点击桌面上的网上邻居,在下拉菜单中,我们选择[属性]选项,在弹出的窗口中我们将[宽带连接]删除,接着点击左边的[创建一个新的连接]选项,如图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7D99M.html" rel="bookmark" class="title">windows系统32位和64位的区别</a>
					<div>
						  内存支持:32位的Windows系统最多只能运行或处理4GB以内的内存,当电脑中安装已经超过4GB以上时,系统不会识别超过4GB的内存.也就说是装了&gt;=4GB以上的内存,装了和没装是一样的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkZELb.html" rel="bookmark" class="title">win8Cisco VPN 442错误怎么办</a>
					<div>
						  有时因为工作或者是遇到要使用Cisco VPN Client的软件,但是在win8系统中经常会出现各种各样的报告错误,其中有一种就是Cisco VPN Client会报442错误,每次出现这个报告 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNQ8OM.html" rel="bookmark" class="title">百度音乐盒不能播放怎么解决？</a>
					<div>
						  1.打开控制面板--&gt;程序和功能(卸载或更改程序),找到左侧栏里的&quot;打开或关闭windows功能&quot;. 2.找到媒体功能,前面的勾全部去掉,重启! 3.然后按前面步骤再把w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwWPKp.html" rel="bookmark" class="title">android-给浏览器发送一个Intent并打开特定的URL</a>
					<div>
						问题描述 给浏览器发送一个Intent并打开特定的URL 我想知道如何给手机的浏览器启动一个intent,再打开一个特定的URL并显示它. 谁能给我个提示吗? 是否有别的方法通过给谷歌地图直接传递坐标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwqYWM.html" rel="bookmark" class="title">为何每次用Android端登录都报出空指针异常，而第二次点击登录就登录的上？？求大神解答！！！</a>
					<div>
						问题描述 代码:publicclassAppLoginServletextendsHttpServlet{privateintresultString=0;publicvoidservice(Http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj0wxp.html" rel="bookmark" class="title">高盛宣称 Windows 的真实份额只有20&percnt;</a>
					<div>
						在桌面电脑操作系统市场,Windows可能仍然占据着绝对的主导地位,但是从全球整个的计算机市场来看,微软正处于沦为边缘玩家的危险之中.这就是金融巨头高盛公司对微软的看法.这份由西雅图时报Seattle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEn1Yp.html" rel="bookmark" class="title">1-java将SqlServer中的一张表备份出来</a>
					<div>
						问题描述 java将SqlServer中的一张表备份出来 我想讲SqlServer中的一张表通过java程序备份出来,该怎么做啊?求教大神 解决方案 你的问题是不会连接SQL 还是不会查询SQL 还是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32dy0z.html" rel="bookmark" class="title">Lucene5学习之排序-Sort</a>
					<div>
						  这回我们来学习Lucene的排序.机智的少年应该已经发现了,IndexSearcher类的search方法有好几个重载:        Java代码   /** Finds the top &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmy1Az.html" rel="bookmark" class="title">server-lightopc Server中项的删除</a>
					<div>
						问题描述 lightopc Server中项的删除 lightopc中的有删除项的方法么?找了挺久,只有添加项的方法,但是没有删除项的方法,请问如何能够删除其中已经添加的项呢?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NjxJM.html" rel="bookmark" class="title">CVE-2017-7494紧急预警：Samba蠕虫级提权漏洞，攻击代码已在网上扩散</a>
					<div>
						本文讲的是CVE-2017-7494紧急预警:Samba蠕虫级提权漏洞,攻击代码已在网上扩散,昨天晚上,开源软件Samba官方发布安全公告,称刚刚修复了软件内一个已有七年之久的严重漏洞(CVE-201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0ZnkM.html" rel="bookmark" class="title">mysql Replace INTO 实例教程</a>
					<div>
						mysql Replace INTO 实例教程 Replace INTO和INSERT INTO的区别,我和他说晚上上我的blog看吧,那时候还在忙,现在从MYSQL手册里找了点东西,MYSQL手册里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE5rvM.html" rel="bookmark" class="title">曹操：实例分析一个好域名对网站的重要性</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 广大站长朋友都知道谷歌在技术和人品上都远远超过百度,但谷歌为什么在中国一直打不过百度呢?很多人要说了,是谷歌不懂中文.那只是百度的忽悠&quot;我们更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5A6QM.html" rel="bookmark" class="title">三黑客入侵网站偷卖游戏卡构成盗窃罪</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 三名&quot;黑客&quot;在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBjJ5z.html" rel="bookmark" class="title">3月10日SLB、CDP、OCS、OSS升级公告</a>
					<div>
						尊敬的用户: 3月10日以下阿里云产品将进行升级,给您带来的不便敬请谅解! 1.阿里云将于2015年3月11日00:00-02:00对OCS服务所在机房做网络变更.变更期间,用户OCS长连接会出现闪断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWo7Oz.html" rel="bookmark" class="title">jquery load&lpar;&rpar;方法使用说明</a>
					<div>
						最近网站做一些改动,需要引用另一个网站的页面,于是用到了jQuery框加中的load方法.挺方便的. load(url, [data], [callback])手册上的说明很直接明了: 载入远程 HT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXK5OAM.html" rel="bookmark" class="title">使用 MySQL 开始 PHP 会话&lowbar;php技巧</a>
					<div>
						默认情况下,PHP会话(session)是通过文件来保存的.这样做有以下几个缺点:     会话文件一般都很小,但文件数却很多,在文件系统中保存许多这样的小文件非常浪费空间,且效率不高.     分布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8veZp.html" rel="bookmark" class="title">怎么针对百度进行网站优化</a>
					<div>
						目前为止每个人都有出现问题,有些站都从第一掉到10来名或者20名左右.初步分析,排除百度人为因素,应该是百度规则发生了变化.计算法则开始侧重某些方面,放淡某些因子.分值比例变化.此次的调整,似乎比之前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Y36Jb.html" rel="bookmark" class="title">国美战略调查 张大中友情客串杜鹃垂帘听政？</a>
					<div>
						国美电器重回追求门店数量的扩张之路,这种战略转向从陈晓3月9日正式辞职前就已经确定.显然,确定这种战略调整的并不是张大中--而是传闻中的垂帘听政者.黄光裕之妻杜鹃--国美幕后的实际操控者. 毫无疑问, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJerBqp.html" rel="bookmark" class="title">版署责令停止46家非法运营网络游戏企业</a>
					<div>
						新闻出版总署日前向全国46家非法运营网络游戏企业当面或公告送达了&lt;责令停止非法运营网络游戏通知书&gt;,要求企业必须在7日内主动停止运营未经审批的网络游戏,逾期未停止者,将由各地&quot;扫 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPDnZp.html" rel="bookmark" class="title">微信营销的揭秘</a>
					<div>
						微信一出,业界哗然.同时微信营销横空出世,意图横扫世界,宣传有无所不能的气势.也有很多人想借微信营销之火逞忽悠之能先捞一篇.也有些不知天高地厚狂妄至极的人也宣扬自己是中国微信营销实战NO.1,叫人唏嘘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoXkmM.html" rel="bookmark" class="title">Viv：一位智能经过全新升级的助手</a>
					<div>
						摘要: 2011年,苹果刚发布iOS 5时推出的人工智能个人助理Siri一度引发了大众的使用热潮,但是当大家了解到其人工智能程度其实相当局限是,这股热度已经退烧.不信你问问现在还有几个iO 2011年 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
